byte setupIOExpander()
{
	if(!aw.begin(0x58)) { return false; }
	aw.pinMode(AWEXP_SPKR_SD, OUTPUT);
	aw.digitalWrite(AWEXP_SPKR_SD, 1); //enable speaker
	aw.pinMode(AWEXP_SD_PWR, OUTPUT);
	aw.digitalWrite(AWEXP_SD_PWR, 0); //start SD powered on
	aw.pinMode(AWEXP_SD_DET, INPUT); //sd card detect
	aw.pinMode(AWEXP_BUTTON_UP, INPUT);
	aw.pinMode(AWEXP_BUTTON_DOWN, INPUT);
	aw.pinMode(AWEXP_BUTTON_LEFT, INPUT);
	aw.pinMode(AWEXP_BUTTON_RIGHT, INPUT);
	aw.pinMode(AWEXP_BUTTON_OK, INPUT);
	aw.pinMode(AWEXP_BUTTON_SEL, INPUT);
  return true;
}

#define AW_INPUTS_MASK ((1UL << AWEXP_BUTTON_DOWN) | (1UL << AWEXP_BUTTON_LEFT) | (1UL << AWEXP_BUTTON_UP) | (1UL << AWEXP_BUTTON_RIGHT) | (1UL << AWEXP_BUTTON_OK) | (1UL << AWEXP_BUTTON_SEL) | (1UL << AWEXP_SD_DET))

void readButtons()
{
	last_button_state = button_state;
	button_state = (aw.inputGPIO() & AW_INPUTS_MASK) | digitalRead(SHUTTER_BUTTON);
}

byte justPressed(byte pin)
{
	return bitRead(last_button_state, pin) && !bitRead(button_state, pin);
}

byte justReleased(byte pin)
{
	return !bitRead(last_button_state, pin) && bitRead(button_state, pin);
}

byte isPressed(byte pin)
{
  return !bitRead(button_state, pin);
}

void setNeopixel(byte r, byte g, byte b)
{
  neopixel.setPixelColor(0, neopixel.Color(r, g, b));
	neopixel.show();
}

void beep(uint16_t freq, uint16_t time)
{
  if(option_beep->enabled)
  {
    tone(SPEAKER, freq, time);
  }
}